/* 
 * Command2P.h - Private definitions for Command2 widget
 * 
 */

#ifndef _XawCommand2P_h
#define _XawCommand2P_h

#include "Command2.h"
#include <X11/neXtaw/LabelP.h>

/***********************************************************************
 *
 * Command Widget Private Data
 *
 ***********************************************************************/

typedef enum {
  HighlightNone,		/* Do not highlight. */
  HighlightWhenUnset,		/* Highlight only when unset, this is
				   to preserve current command widget 
				   functionality. */
  HighlightAlways		/* Always highlight, lets the toggle widget
				   and other subclasses do the right thing. */
} XtCommandHighlight;

/************************************
 *
 *  Class structure
 *
 ***********************************/


   /* New fields for the Command widget class record */
typedef struct _Command2Class 
  {
    int makes_compiler_happy;  /* not used */
  } Command2ClassPart;

   /* Full class record declaration */
typedef struct _Command2ClassRec {
    CoreClassPart	core_class;
    SimpleClassPart	simple_class;
    ThreeDClassPart	threeD_class;
    LabelClassPart	label_class;
    Command2ClassPart   command_class;
} Command2ClassRec;

extern Command2ClassRec command2ClassRec;

/***************************************
 *
 *  Instance (widget) structure 
 *
 **************************************/

    /* New fields for the Command widget record */
typedef struct {
    /* resources */
    Dimension   highlight_thickness;
    XtCallbackList callbacks;

    /* private state */
    Pixmap      	gray_pixmap;
    GC          	normal_GC;
    GC          	inverse_GC;
    Boolean     	set;
    XtCommandHighlight	highlighted;
    Boolean		was_set;
    /* more resources */
    int			shape_style;    
    Dimension		corner_round;
} Command2Part;


/*    XtEventsPtr eventTable;*/


   /* Full widget declaration */
typedef struct _Command2Rec {
    CorePart         core;
    SimplePart	     simple;
    ThreeDPart       threeD;
    LabelPart	     label;
    Command2Part     command;
} Command2Rec;

#endif /* _XawCommandP_h */


