/* 
 * GroupBoxP.h - Private definitions for GroupBox widget
 * 
 */

#ifndef _XawGroupBoxP_h
#define _XawGroupBoxP_h

#include "GroupBox.h"
#include <X11/neXtaw/ThreeDP.h>

typedef struct {int foo;} GroupBoxClassPart;

typedef struct _GroupBoxClassRec {
    CoreClassPart			core_class;
    SimpleClassPart		simple_class;
    ThreeDClassPart     threeD_class;
    GroupBoxClassPart	label_class;
} GroupBoxClassRec;

extern GroupBoxClassRec groupBoxClassRec;

typedef struct {
    Pixel			foreground;
    XFontStruct	*font;
    XFontSet		fontset;
    char				*label;
    XtJustify		justify;
    Dimension		internal_width;
    Dimension		internal_height;
    Pixmap			pixmap;
    Boolean			resize;
    unsigned 		char encoding;
    Pixmap			left_bitmap;
#ifdef XPM_TILE
    Pixmap 			background_tile;	/* for background tiling */
#endif
    GC				normal_GC;
    GC         	gray_GC;
    Pixmap			stipple;
    Position		label_x;
    Position		label_y;
    Dimension		gb_width;
    Dimension		gb_height;
    Dimension		label_width;
    Dimension		label_height;
    Dimension		label_len;
    int				lbm_y;		
    unsigned int 	lbm_width, lbm_height;	
} GroupBoxPart;


typedef struct _GroupBoxRec {
    CorePart		core;
    SimplePart		simple;
    ThreeDPart  	threeD;
    GroupBoxPart	label;
} GroupBoxRec;

#define LEFT_OFFSET(lw) ((lw)->label.left_bitmap \
			 ? (lw)->label.lbm_width + (lw)->label.internal_width \
			 : 0)

#endif /* _XawGroupBoxP_h */
