#include "dialog.h"
#include "../Widgets/Command2.h"

extern		WMAppContext	*WMapp;
Atom 		DIALOG_DELETE, DIALOG_MINIATURIZE;
enum Dialog_RV	result;
Widget	  	dialogShell,
	  	  mainDialogForm,
		    dialogButton1,
		    dialogButton2,
		    dialogLabel;

void Button2Click(Widget a,XtPointer b,XtPointer c)
{
	result = DIALOG_BUTTON2;
	XtPopdown(dialogShell);
}

void Button1Click(Widget a,XtPointer b,XtPointer c)
{
	result = DIALOG_BUTTON1;
	XtPopdown(dialogShell);
}

void InitDialog(Widget toplevel)
{
	XFontStruct		*defaultfont;

	dialogShell = XtVaCreatePopupShell("",
			transientShellWidgetClass, toplevel,
			XtNborderWidth, (XtArgVal)0,
			XtNdefaultDistance, (XtArgVal)0,
			XtNwidth,(XtArgVal)(250),
			XtNheight,(XtArgVal)(100),
			XtNx,300,
			XtNy,350,
			NULL);
	mainDialogForm = XtVaCreateManagedWidget("dialogForm",
			formWidgetClass, dialogShell,
			XtNborderWidth, (XtArgVal)0,
			XtNdefaultDistance, (XtArgVal)0,
			XtNwidth,(XtArgVal)(250),
			XtNheight,(XtArgVal)(100),
			XtNleft,XtChainLeft,
			XtNright,XtChainRight,
			XtNtop,XtChainTop,
			XtNbottom,XtChainBottom,
			NULL);
	dialogLabel = XtVaCreateManagedWidget("dialogLabel",
			labelWidgetClass, mainDialogForm,
			XtNwidth,300,
			XtNborderWidth,(XtArgVal)0,
			XtNleft,XtChainLeft,
			XtNright,XtChainLeft,
			XtNtop,XtChainTop,
			XtNbottom,XtChainTop,
			XtNhorizDistance,(XtArgVal)70,
			XtNvertDistance,(XtArgVal)15,
			XtNjustify,XtJustifyLeft,
			NULL); 
	dialogButton1 = XtVaCreateManagedWidget("dialogButton1",
 			commandWidgetClass, mainDialogForm,
			XtNheight,(XtArgVal)25,
			XtNwidth,95,
			XtNhorizDistance,(XtArgVal)25,
			XtNvertDistance,(XtArgVal)70,
			XtNborderWidth, 0,
			XtNlabel,"No",
			XtNjustify,XtJustifyLeft,
			XtNleft,XtChainLeft,
			XtNright,XtChainLeft,
			XtNtop,XtChainTop,
			XtNbottom,XtChainTop,
			NULL);
	XtVaGetValues(dialogButton1,XtNfont,&defaultfont,NULL);
	dialogButton2 = XtVaCreateManagedWidget("dialogButton2",
 			command2WidgetClass, mainDialogForm,
			XtNheight,(XtArgVal)25,
			XtNwidth,95,
			XtNhorizDistance,(XtArgVal)130,
			XtNvertDistance,(XtArgVal)70,
			XtNborderWidth, 0,
			XtNfont,defaultfont,
			XtNlabel,"Yes",
			XtNjustify,XtJustifyLeft,
			XtNleft,XtChainLeft,
			XtNright,XtChainLeft,
			XtNtop,XtChainTop,
			XtNbottom,XtChainTop,
			NULL);
	XtAddCallback(dialogButton1,XtNcallback,Button1Click,NULL);
	XtAddCallback(dialogButton2,XtNcallback,Button2Click,NULL);
}

void DialogDeleteHandler(Widget a,XtPointer b,XEvent *event,Boolean *c)
{
	if(event->type != ClientMessage)	return;
	if(event->xclient.format != 32)		return;
	XtPopdown(dialogShell);
	result=DIALOG_CLOSE;
}

enum Dialog_RV DrawDialogWindow(char *question,char *button1,char *button2,XFontStruct *defaultfont)
{
	result=DIALOG_ERROR;
	XtPopup(dialogShell,XtGrabExclusive);
	{
		Atom prots[2];
		DIALOG_DELETE=XInternAtom(XtDisplay(dialogShell),"WM_DELETE_WINDOW",False);
		prots[0]=DIALOG_DELETE;
		prots[1]=DIALOG_MINIATURIZE;
		XSetWMProtocols(XtDisplay(dialogShell),XtWindow(dialogShell),prots,2);
	}
	XtVaSetValues(dialogLabel,XtNlabel,question,NULL);
	XtVaSetValues(dialogButton1,XtNlabel,button1,NULL);
	XtVaSetValues(dialogButton2,XtNlabel,button2,NULL);
	XtVaSetValues(dialogLabel,XtNfont,defaultfont,NULL);
	XtAddEventHandler(dialogShell,NoEventMask,True,DialogDeleteHandler,NULL);
	WMAppAddWindow(WMapp, XtWindow(dialogShell));   

	while (result==DIALOG_ERROR) {
		XEvent ev;
		XNextEvent(XtDisplay(dialogShell), &ev);
		WMProcessEvent(WMapp, &ev);
		XtDispatchEvent(&ev);
	}
	return result;
}
