#include "headers.h"
#include "file.h"
#include "icon.h"

extern	struct	filenode 	*fileroot;
extern	struct	typenode	*typeroot;
extern	char 	naam[MAX_NAME_LEN];
extern	RImage	*file;
extern	RContext *ctx;
extern 	char	*PixmapPath,*AbsIconConfigFile,*AbsConfigPath;
int 	succes;
int 	numberOfFiles = 0;
long 	totalsize = 0;

extern int find(char *s,char *w,int hoeveelste);

void setDirName(char *s)
{
	strcpy(naam,s);
	fileroot = NULL;	
	numberOfFiles = 0;
}

void freeDir(void)
{
	struct filenode *n,*m;
	n = fileroot;

	while(n != NULL)
	{
		m = n->next;
		free(n);
		n = m;
	}
}

void readDir()
{
	DIR 	*r;
	FILE 	*test;
	struct	stat	s;
	char 	tmp[MAX_NAME_LEN],filename[MAX_NAME_LEN];
	struct 	dirent *d;
	struct	filenode *v,*n;
	
	totalsize = 0;

	n = fileroot;
	while(n != NULL) {
		v = n->next;
		free(n);
		n = v;
	}
	fileroot = NULL;

	numberOfFiles = 0;
	if((r = opendir(naam)) == NULL) succes = 0;
	else {
		while(d = readdir(r),d != NULL) {
			v = fileroot;
			numberOfFiles++;
			if((v != NULL) && (strcmp(v->naam,d->d_name) <= 0)) {
				strcpy(tmp,naam);
				lstat(strcat(tmp,d->d_name),&s);
				while (((v->next) != NULL) && (strcmp((v->next)->naam,d->d_name)<=0)) v = v->next;
				n = (struct filenode *) malloc(sizeof(struct filenode));
				n->next = v->next;
				v->next = n;
				strcpy(n->naam,d->d_name);
				n->size = s.st_size;
				n->date = s.st_ctime;
				totalsize += s.st_size;
			} else {
				if ((strcmp(d->d_name,".")!=0) && (strcmp(d->d_name,"..")!=0)){
					strcpy(tmp,naam);
					lstat(strcat(tmp,d->d_name),&s);
					n = (struct filenode *) malloc(sizeof(struct filenode));
					strcpy(n->naam,d->d_name);
					n->size = s.st_size;
					n->date = s.st_ctime;
					totalsize += s.st_size;
					n->next = v;
					fileroot = n;
				}
			}
		}	
		closedir(r);
		succes = 1;

		v = fileroot;
		while (v != NULL) {
			strcpy(filename,naam);
			if(filename[strlen(filename)] != '/') strcat(filename,"/");
			strcat(filename,v->naam);
			if ((test = fopen(filename,"a")) == NULL) v->dir = 1;
			else { fclose(test); v->dir = 0; }
			v = v->next;
		}
		v = NULL;
	}
}

// mf = maximum files in dir
// ms = maximum (total) size of files in dir
void cleanupDir(int mf,int ms)
{
	int	oldest;
	struct 	filenode	*n,*m;
	char		c[MAX_NAME_LEN];
		
	if (fileroot == NULL) return;
	while (((totalsize/1024) > ms) || (numberOfFiles > mf)) {
		n = fileroot;
		oldest = localtime(&fileroot->date)->tm_yday;
		while (n != NULL) {
			if (oldest > localtime(&n->date)->tm_yday) oldest=localtime(&n->date)->tm_yday;
			n = n->next;
		}
		n = fileroot;
		if (localtime(&fileroot->date)->tm_yday == oldest) {
			strcpy(c,"rm -R \"");
			strcat(c,naam);
			strcat(c,n->naam);
			strcat(c,"\"");
			system(c);
			fileroot = fileroot->next;
			totalsize -= n->size;
			numberOfFiles--;
			free(n);			
		} else {
			while ((n->next != NULL)&& (localtime(&n->next->date)->tm_yday != oldest)) n = n->next;
			if (n->next != NULL) {
				m = n->next;
				n->next = m->next;				
				strcpy(c,"rm -R \"");
				strcat(c,naam);
				strcat(c,m->naam);
				strcat(c,"\"");
				system(c);
				totalsize -= m->size;
				numberOfFiles--;
				free(m);			
			}
		}
	}
}

/******************************************************************
 * Types Section                                                  *
 ******************************************************************/
 
 /*
    return 1 if succesfull or 0 when the file does not exist (or 
    another problem has occured).
 */

int exists(char *path)
{
	struct stat stats;

	return (!lstat(path, &stats));
}

char *searchPath(char *s1, char *p, char *s2)
{
	char	*s, *t;

	if (*s2 == '/' || !p) return (strcpy(s1, s2));
	for (s = p; *s; s = t) {
		int l;
		if (!(t = strchr(s, ':'))) t = strchr(s, 0);
		if (s == t) goto next;
		if (s[0] == '.') if ((t = s+1)) s = t;
		else if (s[1] == '/') s += 2;
		l = t-s;
		strncpy(s1, s, l);
		if (l > 0 && s1[l - 1] != '/') s1[l] = '/', l++;
		strcpy(s1+l, s2);
		if (exists(s1)) return s1;
 next:
		if (*t) t++;
	}
	return (strcpy(s1, s2));
}

 
int readFilesRC(void)
{
	FILE 	*f;
	char	regel[80],temp[1024],tmp[1024];
	char	fullname[1024];
	int	p,i;
	struct	typenode	*n,*m;
	RImage*	icon;

	if ((f = fopen(AbsIconConfigFile,"r"))!=NULL) {
		do {
			fgets(regel,79,f);
			if (feof(f)==0) {
				p = find(regel,":",3);
				if ((p != -1)&&((regel[0] != '<')&&(regel[0] != '#'))) {
					n = (struct typenode *) malloc(sizeof(struct filenode));
					
					i = p = find(regel,":",1);
					n->extension = (char *) malloc(p+1);
					strncpy(n->extension,regel,p);
					n->extension[p] = '\0';
					
					p = find(regel,":",2);
					strncpy(temp,regel+i+1,p-i-1);
					temp[p-i-1] = '\0';
					
					
					sprintf(tmp,"%sXPM/clear.xpm",AbsConfigPath);
					n->icon = RLoadImage(ctx, tmp,0);
				   if (!n->icon) { puts(RErrorString);	exit(1); }

					icon = RLoadImage(ctx, searchPath(fullname, PixmapPath, temp),0);
				   if (!icon) { puts(RErrorString);	exit(1); }
				   
				   RCombineArea(n->icon, icon, 0, 0, icon->width, icon->height, 0, 0);
				   
				   RDestroyImage(icon);
				   
					n->next = NULL;

					if (typeroot == NULL) {
						typeroot = n;
					} else {
						m = typeroot;
						while (m->next != NULL) m = m->next;
						m->next = n;
					}
				}
			}
		} while (feof(f)==0);
		
		fclose(f);
	} else return 0;

	return 1; 
}
 
RImage* pixmapForType(char *pathfile)
{
	struct	typenode	*n = typeroot;
	char	temp[80];
	int	p;
	
	while (n != NULL) {
		if (strcmp(pathfile,n->extension)==0) return n->icon;
		if ((p = find(n->extension,"*",1)) != -1) {
			if (p > 0) {
				strncpy(temp,n->extension,p);
				temp[p] = '\0';
				if (find(pathfile,temp,1)==0) return n->icon;
			} else {
				strcpy(temp,n->extension+1);
				if (strcmp(temp,pathfile+strlen(pathfile)-strlen(temp))==0) return n->icon;
			}
		}
		n = n->next;
	}
	return file; 
}
 
