#include "windows.h"
#include "icon.h"
#include "../Widgets/GroupBox.h"

extern 	Pixel		background,foreground,darkgray,lightgray;
extern 	WMAppContext	*WMapp;
extern	Atom 		WM_DELETE_WINDOW, GS_WM_MINIATURIZE_WINDOW;
extern 	Display		*dpy;			
extern	RImage		*recycler;
extern 	int		Delete,RootDrop;
extern	RContext 	*ctx;
extern	Pixmap		pix;

extern void writeConfig(void);

extern Widget	toplevel,			// initial widget
	  Form,				// main form
	    icon,			// the recycler icon
	    border1,
	    border2,
	    border3,
	    border4,
	    view,			// viewport with scrollbar
	      form2,			// on this form all icons & labels are placed
	infoShell,			// main info popup shell
	    mainInfoForm,		// main form for the info popup
		infoIcon,
		infoLabel,
     	prefShell,			// main preferences popup shell
	    mainPrefForm,		// main form for the preferences popup
		toggleAlways,		// option indicating that files should always be deleted
		toggleAsk,		// option indicating that the user will be asked if the files should be deleted
		toggleNever,		// option indicating that files should not be deleted
		prefGroupBox1,		// 
		toggleDel,		// option indicating that the user will be asked if the files should be deleted
		toggleNop,		// option indicating that files should not be deleted
		prefGroupBox2,		// 
     	legalShell,			// main popup shell for legal stuff
	    mainLegalForm,		// main form for the legal stuff
		legalText, 		// Text containing GNU-GPL
		legalGroupBox 		// a groupbox around the text
;


// this function initializes all widgets exept the icons (deleted items)

void DrawWindow()
{
	XColor		exact,bijna,darker,lighter;
	float 		rv, gv, bv;
	
	XLookupColor(dpy, DefaultColormap(dpy,DefaultScreen(dpy)),"gray",&exact,&bijna);

	rv = (float)bijna.red * 0.8;
	gv = (float)bijna.green * 0.8;
	bv = (float)bijna.blue * 0.8;

	darker.red   = (short)(rv<0?0:rv);
	darker.green = (short)(gv<0?0:gv);
	darker.blue  = (short)(bv<0?0:bv);

	if (XAllocColor(dpy, DefaultColormap(dpy, DefaultScreen(dpy)),&darker)) darkgray = darker.pixel;

	rv = (float)bijna.red * 1.2;
	gv = (float)bijna.green * 1.2;
	bv = (float)bijna.blue * 1.2;

	lighter.red   = (short)(rv>256?256:rv);
	lighter.green = (short)(gv>256?256:gv);
	lighter.blue  = (short)(bv>256?256:bv);

	if (XAllocColor(dpy, DefaultColormap(dpy, DefaultScreen(dpy)),&lighter)) lightgray = lighter.pixel;

	Form=XtVaCreateManagedWidget("Form",
			formWidgetClass, toplevel,
			XtNborderWidth, (XtArgVal)0,
			XtNdefaultDistance, (XtArgVal)0,
			XtNleft,XtChainLeft,
			XtNright,XtChainRight,
			XtNtop,XtChainTop,
			XtNbottom,XtChainBottom,
			NULL);

	XtVaGetValues(Form,XtNbackground,&background,NULL);
	XtVaGetValues(Form,XtNforeground,&foreground,NULL);

	RConvertImage(ctx, recycler, &pix);
	
	icon = XtVaCreateManagedWidget("Icon",
			toggleWidgetClass, Form,
			XtNleft,XtChainLeft,
			XtNright,XtChainLeft,
			XtNtop,XtChainTop,
			XtNbottom,XtChainBottom,
			XtNwidth,(XtArgVal)(VSIZE)+2,
			XtNheight,(XtArgVal)(VSIZE),
			XtNbitmap,pix,
			XtNhorizDistance,(XtArgVal)0,
			XtNvertDistance,(XtArgVal)0,
			XtNborderWidth, 1,
			XtNborder,darkgray,
			NULL);
	XtVaGetValues(icon,XtNbackground,&background,NULL);
	border1 = XtVaCreateManagedWidget("border1",
			formWidgetClass, Form,
			XtNborderWidth, (XtArgVal)0,
			XtNbackground,background,
			XtNhorizDistance,(XtArgVal)(VSIZE),
			XtNwidth,(XtArgVal)5,
			XtNheight,(XtArgVal)(VSIZE),
			XtNdefaultDistance, (XtArgVal)0,
			XtNleft,XtChainLeft,
			XtNright,XtChainLeft,
			XtNtop,XtChainTop,
			XtNbottom,XtChainBottom,
			NULL);
	border2 = XtVaCreateManagedWidget("border2",
			formWidgetClass, Form,
			XtNborderWidth, (XtArgVal)0,
			XtNbackground,background,
			XtNhorizDistance,(XtArgVal)0,
			XtNvertDistance,(XtArgVal)(VSIZE-2),
			XtNwidth,(XtArgVal)HSIZE,
			XtNheight,(XtArgVal)2,
			XtNdefaultDistance, (XtArgVal)0,
			XtNtop,XtChainBottom,
			XtNbottom,XtChainBottom,
			XtNleft,XtChainLeft,
			XtNright,XtChainRight,
			NULL);
	border3 = XtVaCreateManagedWidget("border1",
			formWidgetClass, Form,
			XtNborderWidth, (XtArgVal)0,
			XtNbackground,background,
			XtNhorizDistance,(XtArgVal)(HSIZE-2),
			XtNwidth,(XtArgVal)3,
			XtNheight,(XtArgVal)(VSIZE),
			XtNdefaultDistance, (XtArgVal)0,
			XtNleft,XtChainRight,
			XtNright,XtChainRight,
			XtNtop,XtChainTop,
			XtNbottom,XtChainBottom,
			NULL);
	border4 = XtVaCreateManagedWidget("border2",
			formWidgetClass, Form,
			XtNborderWidth, (XtArgVal)0,
			XtNbackground,background,
			XtNhorizDistance,(XtArgVal)0,
			XtNvertDistance,(XtArgVal)0,
			XtNwidth,(XtArgVal)HSIZE,
			XtNheight,(XtArgVal)2,
			XtNdefaultDistance, (XtArgVal)0,
			XtNtop,XtChainTop,
			XtNbottom,XtChainTop,
			XtNleft,XtChainLeft,
			XtNright,XtChainRight,
			NULL);

	view = XtVaCreateManagedWidget("view",
			viewportWidgetClass, Form,
			XtNbackground,background,
			XtNborderWidth, (XtArgVal)0,
			XtNborder,darkgray,
			XtNdefaultDistance, (XtArgVal)0,
			XtNhorizDistance,(XtArgVal)(VSIZE)+1,
			XtNleft,XtChainLeft,
			XtNright,XtChainRight,
			XtNtop,XtChainTop,
			XtNbottom,XtChainBottom,
			XtNwidth,(XtArgVal)(HSIZE-VSIZE), 
			XtNheight,(XtArgVal)(VSIZE), 
			XtNforceBars,(XtArgVal)True,
			XtNallowHoriz,(XtArgVal)True,
			XtNuseBottom,(XtArgVal)True,
			NULL);
	form2 = XtVaCreateManagedWidget("form2",
			formWidgetClass, view,
			XtNborder,lightgray,
			XtNborderWidth, (XtArgVal)1,
			XtNbackground,background,
			XtNvertDistance,(XtArgVal)0,
			XtNwidth,(XtArgVal)(HSIZE-VSIZE),
			XtNheight,(XtArgVal)(VSIZE),
			XtNdefaultDistance, (XtArgVal)0,
			NULL);
}

void initializeInfoWindow()
{
	infoShell = XtVaCreatePopupShell("info panel",
			transientShellWidgetClass, toplevel,
			XtNborderWidth, (XtArgVal)0,
			XtNdefaultDistance, (XtArgVal)0,
			XtNwidth,(XtArgVal)(400),
			XtNheight,(XtArgVal)(100),
			XtNx,125,
			XtNy,50,
			NULL);
	mainInfoForm = XtVaCreateManagedWidget("infoForm",
			formWidgetClass, infoShell,
			XtNborderWidth, (XtArgVal)0,
			XtNdefaultDistance, (XtArgVal)0,
			XtNwidth,(XtArgVal)(400),
			XtNheight,(XtArgVal)(100),
			XtNleft,XtChainLeft,
			XtNright,XtChainRight,
			XtNtop,XtChainTop,
			XtNbottom,XtChainBottom,
			NULL);

	RConvertImage(ctx, recycler, &pix);
	
	infoIcon = XtVaCreateManagedWidget("Icon",
			toggleWidgetClass, mainInfoForm,
			XtNwidth,(XtArgVal)60,
			XtNheight,(XtArgVal)60,
			XtNbitmap,pix,
			XtNborderWidth, 0,
			XtNleft,XtChainLeft,
			XtNright,XtChainLeft,
			XtNtop,XtChainTop,
			XtNbottom,XtChainBottom,
			NULL);
	infoLabel = XtVaCreateManagedWidget("label",
			labelWidgetClass, mainInfoForm,
			XtNbackground,background,
			XtNwidth,300,
			XtNborderWidth,(XtArgVal)0,
			XtNlabel,"WindowMaker Recycler \nmail any suggestions/bug reports to :\n\n        O.Kerpershoek\n        kerpe500@hio.tem.nhl.nl",
			XtNleft,XtChainLeft,
			XtNright,XtChainLeft,
			XtNtop,XtChainTop,
			XtNbottom,XtChainTop,
			XtNhorizDistance,(XtArgVal)70,
			XtNvertDistance,(XtArgVal)5,
			XtNjustify,XtJustifyLeft,
			NULL); 
}

void InfoDeleteHandler(Widget a,XtPointer b,XEvent *event,Boolean *c)
{
	if(event->type != ClientMessage)	return;
	if(event->xclient.format != 32)		return;
	XtPopdown(infoShell);
}

void DrawInfoWindow(void *a, int b, Time c)
{
	XtPopup(infoShell,XtGrabExclusive);
	{
		Atom prots[2];
		WM_DELETE_WINDOW=XInternAtom(dpy,"WM_DELETE_WINDOW",False);
		prots[0]=WM_DELETE_WINDOW;
		prots[1]=GS_WM_MINIATURIZE_WINDOW;
		XSetWMProtocols(dpy,XtWindow(infoShell),prots,2);
	}
	XtAddEventHandler(infoShell,NoEventMask,True,InfoDeleteHandler,NULL);
	WMAppAddWindow(WMapp, XtWindow(infoShell));   
}

void initializeLegalWindow()
{
	legalShell = XtVaCreatePopupShell("legal stuff",
			transientShellWidgetClass, toplevel,
			XtNborderWidth, (XtArgVal)0,
			XtNdefaultDistance, (XtArgVal)0,
			XtNwidth,(XtArgVal)(485),
			XtNheight,(XtArgVal)(380),
			XtNx,125,
			XtNy,50,
			NULL);
	mainLegalForm = XtVaCreateManagedWidget("legalForm",
			formWidgetClass, legalShell,
			XtNborderWidth, (XtArgVal)0,
			XtNdefaultDistance, (XtArgVal)0,
			XtNleft,XtChainLeft,
			XtNright,XtChainRight,
			XtNtop,XtChainTop,
			XtNbottom,XtChainBottom,
			NULL);
	      
	legalText = XtVaCreateManagedWidget("legalText",
			labelWidgetClass, mainLegalForm,
			XtNbackground,background,
			XtNhorizDistance,(XtArgVal)30,
			XtNvertDistance,(XtArgVal)30,
			XtNborderWidth,(XtArgVal)0,
			XtNlabel,"
Recycler - modification of the OffiX waste basket
Copyright (C) 1997  Ocker Kerpershoek\n
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.\n
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.\n
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.",
			XtNjustify,XtJustifyLeft,
			XtNleft,XtChainLeft,
			XtNright,XtChainLeft,
			XtNtop,XtChainTop,
			XtNbottom,XtChainTop,
			NULL); 
	      
	legalGroupBox = XtVaCreateManagedWidget("legalGroupBox",
			groupBoxWidgetClass, mainLegalForm,
			XtNborderWidth,(XtArgVal)0,
			XtNlabel,(XtArgVal)" GNU General Public License ",
			XtNgbWidth,(XtArgVal)475,
			XtNgbHeight,(XtArgVal)370,
			XtNinternalWidth,(XtArgVal)300,
			XtNinternalHeight,(XtArgVal)300,
			XtNhorizDistance,(XtArgVal) 5,
			XtNvertDistance,(XtArgVal) 5,
			XtNleft,XtChainLeft,
			XtNright,XtChainLeft,
			XtNtop,XtChainTop,
			XtNbottom,XtChainTop,
			XtNjustify,XtJustifyLeft,
			NULL);

}

void LegalDeleteHandler(Widget a,XtPointer b,XEvent *event,Boolean *c)
{
	if(event->type != ClientMessage)	return;
	if(event->xclient.format != 32)		return;
	XtPopdown(legalShell);
}

void DrawLegalWindow(void *a, int b, Time c)
{
	XtPopup(legalShell,XtGrabExclusive);
	{
		Atom prots[2];
		WM_DELETE_WINDOW=XInternAtom(dpy,"WM_DELETE_WINDOW",False);
		prots[0]=WM_DELETE_WINDOW;
		prots[1]=GS_WM_MINIATURIZE_WINDOW;
		XSetWMProtocols(dpy,XtWindow(legalShell),prots,2);
	}
	XtAddEventHandler(legalShell,NoEventMask,True,LegalDeleteHandler,NULL);
	WMAppAddWindow(WMapp, XtWindow(legalShell));   
}

void PrefDelClick(Widget w,XtPointer a,XtPointer b)
{
	XtVaSetValues(toggleAlways,XtNstate,False,NULL);
	XtVaSetValues(toggleAsk,XtNstate,False,NULL);
	XtVaSetValues(toggleNever,XtNstate,False,NULL);
	XtVaSetValues(w,XtNstate,True,NULL);
}

void PrefRDropClick(Widget w,XtPointer a,XtPointer b)
{
	XtVaSetValues(toggleDel,XtNstate,False,NULL);
	XtVaSetValues(toggleNop,XtNstate,False,NULL);
	XtVaSetValues(w,XtNstate,True,NULL);
}

void initializePrefWindow()
{
	prefShell = XtVaCreatePopupShell("preferences",
			transientShellWidgetClass, toplevel,
			XtNborderWidth, (XtArgVal)0,
			XtNdefaultDistance, (XtArgVal)0,
			XtNwidth,(XtArgVal)(290),
			XtNheight,(XtArgVal)(260),
			XtNx,125,
			XtNy,50,
			NULL);
	mainPrefForm = XtVaCreateManagedWidget("prefForm",
			formWidgetClass, prefShell,
			XtNborderWidth, (XtArgVal)0,
			XtNdefaultDistance, (XtArgVal)0,
			XtNleft,XtChainLeft,
			XtNright,XtChainRight,
			XtNtop,XtChainTop,
			XtNbottom,XtChainBottom,
			NULL);
	      
	toggleAlways = XtVaCreateManagedWidget("",
 			toggleWidgetClass, mainPrefForm,
			XtNheight,(XtArgVal)20,
			XtNwidth,200,
			XtNhorizDistance,(XtArgVal)50,
			XtNvertDistance,(XtArgVal)42,
			XtNborderWidth, 0,
			XtNlabel,"Just delete files",
			XtNjustify,XtJustifyLeft,
			XtNtoggleStyle,XtToggleRadio,
			XtNleft,XtChainLeft,
			XtNright,XtChainLeft,
			XtNtop,XtChainTop,
			XtNbottom,XtChainTop,
			NULL);
	toggleAsk = XtVaCreateManagedWidget("",
 			toggleWidgetClass, mainPrefForm,
			XtNheight,(XtArgVal)20,
			XtNwidth,200,
			XtNhorizDistance,(XtArgVal)50,
			XtNvertDistance,(XtArgVal)62,
			XtNborderWidth, 0,
			XtNlabel,"Ask for confirmation",
			XtNjustify,XtJustifyLeft,
			XtNtoggleStyle,XtToggleRadio,
			XtNleft,XtChainLeft,
			XtNright,XtChainLeft,
			XtNtop,XtChainTop,
			XtNbottom,XtChainTop,
			NULL);
	toggleNever = XtVaCreateManagedWidget("",
 			toggleWidgetClass, mainPrefForm,
			XtNheight,(XtArgVal)20,
			XtNwidth,200,
			XtNhorizDistance,(XtArgVal)50,
			XtNvertDistance,(XtArgVal)82,
			XtNborderWidth, 0,
			XtNlabel,"Do not delete files",
			XtNjustify,XtJustifyLeft,
			XtNtoggleStyle,XtToggleRadio,
			XtNleft,XtChainLeft,
			XtNright,XtChainLeft,
			XtNtop,XtChainTop,
			XtNbottom,XtChainTop,
			NULL);

	XtAddCallback(toggleAlways,XtNcallback,PrefDelClick,NULL);
	XtAddCallback(toggleAsk,XtNcallback,PrefDelClick,NULL);
	XtAddCallback(toggleNever,XtNcallback,PrefDelClick,NULL);
		
	prefGroupBox1 = XtVaCreateManagedWidget("prefGroupBox 1",
			groupBoxWidgetClass, mainPrefForm,
			XtNborderWidth,(XtArgVal)0,
			XtNlabel,(XtArgVal)"When a file is to be removed...",
			XtNgbWidth,(XtArgVal)250,
			XtNgbHeight,(XtArgVal)100,
			XtNinternalWidth,(XtArgVal)150,
			XtNinternalHeight,(XtArgVal)50,
			XtNhorizDistance,(XtArgVal) 20,
			XtNvertDistance,(XtArgVal) 20,
			XtNleft,XtChainLeft,
			XtNright,XtChainLeft,
			XtNtop,XtChainTop,
			XtNbottom,XtChainTop,
			XtNjustify,XtJustifyLeft,
			NULL);

	switch(Delete) {
		case 1: XtVaSetValues(toggleAlways,XtNstate,True,NULL); break;
		case 3: XtVaSetValues(toggleNever,XtNstate,True,NULL); break;
		default: XtVaSetValues(toggleAsk,XtNstate,True,NULL); break;
	}	

	toggleDel = XtVaCreateManagedWidget("",
 			toggleWidgetClass, mainPrefForm,
			XtNheight,(XtArgVal)20,
			XtNwidth,200,
			XtNhorizDistance,(XtArgVal)50,
			XtNvertDistance,(XtArgVal)162,
			XtNborderWidth, 0,
			XtNlabel,"Delete the file",
			XtNjustify,XtJustifyLeft,
			XtNtoggleStyle,XtToggleRadio,
			XtNleft,XtChainLeft,
			XtNright,XtChainLeft,
			XtNtop,XtChainTop,
			XtNbottom,XtChainTop,
			NULL);
	toggleNop = XtVaCreateManagedWidget("",
 			toggleWidgetClass, mainPrefForm,
			XtNheight,(XtArgVal)20,
			XtNwidth,200,
			XtNhorizDistance,(XtArgVal)50,
			XtNvertDistance,(XtArgVal)182,
			XtNborderWidth, 0,
			XtNlabel,"Do nothing",
			XtNjustify,XtJustifyLeft,
			XtNtoggleStyle,XtToggleRadio,
			XtNleft,XtChainLeft,
			XtNright,XtChainLeft,
			XtNtop,XtChainTop,
			XtNbottom,XtChainTop,
			NULL);

	XtAddCallback(toggleDel,XtNcallback,PrefRDropClick,NULL);
	XtAddCallback(toggleNop,XtNcallback,PrefRDropClick,NULL);
		
	prefGroupBox2 = XtVaCreateManagedWidget("legalGroupBox",
			groupBoxWidgetClass, mainPrefForm,
			XtNborderWidth,(XtArgVal)0,
			XtNlabel,(XtArgVal)"When a rootdrop occures...",
			XtNgbWidth,(XtArgVal)250,
			XtNgbHeight,(XtArgVal)100,
			XtNinternalWidth,(XtArgVal)150,
			XtNinternalHeight,(XtArgVal)50,
			XtNhorizDistance,(XtArgVal) 20,
			XtNvertDistance,(XtArgVal) 140,
			XtNleft,XtChainLeft,
			XtNright,XtChainLeft,
			XtNtop,XtChainTop,
			XtNbottom,XtChainTop,
			XtNjustify,XtJustifyLeft,
			NULL);

	switch(RootDrop) {
		case 1: XtVaSetValues(toggleDel,XtNstate,True,NULL); break;
		default: XtVaSetValues(toggleNop,XtNstate,True,NULL); break;
	}	


}

void PrefDeleteHandler(Widget a,XtPointer b,XEvent *event,Boolean *c)
{
	Boolean	result;
	
	if(event->type != ClientMessage)	return;
	if(event->xclient.format != 32)		return;
	XtPopdown(prefShell);
	
	XtVaGetValues(toggleDel,XtNstate,&result,NULL);
	if (result == True) RootDrop = 1;
	else RootDrop = 2;

	XtVaGetValues(toggleAlways,XtNstate,&result,NULL);
	if (result == True) Delete = 1; 
	else {
		XtVaGetValues(toggleNever,XtNstate,&result,NULL);
		if (result == True) Delete = 3; 
		else Delete = 2;
	}
	
	writeConfig();
}

void DrawPrefWindow(void *a, int b, Time c)
{
	XtPopup(prefShell,XtGrabExclusive);
	{
		Atom prots[2];
		WM_DELETE_WINDOW=XInternAtom(dpy,"WM_DELETE_WINDOW",False);
		prots[0]=WM_DELETE_WINDOW;
		prots[1]=GS_WM_MINIATURIZE_WINDOW;
		XSetWMProtocols(dpy,XtWindow(prefShell),prots,2);
	}
	XtAddEventHandler(prefShell,NoEventMask,True,PrefDeleteHandler,NULL);
	WMAppAddWindow(WMapp, XtWindow(prefShell));   
}
